import numpy as np
import properscoring as ps


def crps_score(observations, forecasts):
    """
    Parameters:
    -----------
    observations : numpy.ndarray, shape=(n_samples, n_features)
        True values of a time series.
        Example: [[1, 2], [3, 4], [4, 5], ...]
    forecasts : numpy.ndarray, shape=(n_forecasts, n_samples, n_features)
        Forecasts generated by a model.
        Example: [forecast1, forecast2, forecast3, ...], 
        where forecast1 = [1, 2], [3, 4], [4, 5], ...]
        
    Returns:
    --------
    mean : float
        Mean value of CRPS score.
    std : float
        Standard deviation of the mean CRPS score.
    
    """
    
    forecasts = np.moveaxis(forecasts, [0, 1, 2], [2, 0, 1])
    res = ps.crps_ensemble(observations, forecasts)
    mean = res.mean()
    std  = res.std() / np.sqrt(forecasts.shape[2]) 
    return mean, std


from sklearn.model_selection import train_test_split
from sklearn.ensemble import RandomForestClassifier
from sklearn.tree import DecisionTreeClassifier
from sklearn.linear_model import LogisticRegression
from sklearn.discriminant_analysis import QuadraticDiscriminantAnalysis
from sklearn.metrics import roc_auc_score


def discrepancy_score(observations, forecasts, model='QDA', n_iters=1):
    """
    Parameters:
    -----------
    observations : numpy.ndarray, shape=(n_samples, n_features)
        True values of a time series.
        Example: [[1, 2], [3, 4], [4, 5], ...]
    forecasts : numpy.ndarray, shape=(n_forecasts, n_samples, n_features)
        Forecasts generated by a model.
        Example: [forecast1, forecast2, forecast3, ...], 
        where forecast1 = [1, 2], [3, 4], [4, 5], ...]
    model : sklearn binary classifier
        Possible values: RF, DT, LR, QDA
    n_iters : int
        Number of iteration per one forecast.
        
    Returns:
    --------
    mean : float
        Mean value of discrepancy score.
    std : float
        Standard deviation of the mean discrepancy score.
    
    """
    
    
    scores = []

    X0 = np.concatenate((np.arange(len(observations)).reshape(-1, 1), 
                         observations-forecasts.mean(axis=0)), axis=1)
    y0 = np.zeros(len(observations))
    
    for afc in forecasts:
        
        X1 = np.concatenate((np.arange(len(afc)).reshape(-1, 1), 
                             afc-forecasts.mean(axis=0)), axis=1)
        y1 = np.ones(len(afc))
        
        X = np.concatenate((X0, X1), axis=0)
        y = np.concatenate((y0, y1), axis=0)
        
        for it in range(n_iters):
            X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.5, shuffle=True)
            if model == 'RF':
                clf = RandomForestClassifier(n_estimators=100, max_depth=10, max_features=None)
            elif model == 'DT':
                clf = DecisionTreeClassifier(max_depth=10)
            elif model == 'LR':
                clf = LogisticRegression()
            elif model == 'QDA':
                clf = QuadraticDiscriminantAnalysis()
            clf.fit(X_train, y_train)
            y_pred_test = clf.predict_proba(X_test)[:, 1]
            auc = 2 * roc_auc_score(y_test, y_pred_test) - 1
            scores.append(auc)

    scores = np.array(scores)
    mean = scores.mean()
    std  = scores.std() / np.sqrt(len(scores))
    
    return mean, std